#!/tmp/busybox sh

bkdir="/sdcard/bb-uninstall" ; 
if [ -d "$bkdir" ] ; 
	then 
		busybox echo "Backup folder $bkdir already exists. Please remove it to proceed...">>$bkdir/__Error_Backup_Folder_Already_Exists__.txt ; 
		busybox echo "Backup folder \"$bkdir\" already exists. Please remove it to proceed..." ; 
		exit 1 ; 
	else 
		busybox mkdir $bkdir ; 
		if [ ! -d "$bkdir" ] ; 	 
			then 
				busybox echo "Backup folder \"$bkdir\" could not be created" ; 
				busybox echo "Check if sdcard is present, mounted, has free space or you have permissions!!" ; 
				exit 1 ; 
		fi ; 
fi ; 

bbdir="/system/xbin /system/bin" ; 
ndeletes=0 ; 
for bbpath in $bbdir ; 
	do 
		for f in $(busybox find $bbpath -type l) ; 
			do 
				gnr=$(busybox readlink $f) ; 
				if echo "$gnr" |busybox grep -q busybox ; 
					then 
						busybox echo -e "$f \t is linked to \t $gnr ---> backup up in sdcard then deleted">>$bkdir/bb-uninstall.log ; 
						bkfile=`busybox echo "$f" | busybox tr '/' '.'` ; 
						bkfile=bak$bkfile ; 
						busybox tar zcf $bkdir/$bkfile.tar.gz -C / ${f:1} ; 
						if [ ! -f "$bkdir/$bkfile.tar.gz" ] ; 
							then 
								busybox echo "Error while creating backup file \"$bkdir/$bkfile.tar.gz\"" ; 
								busybox echo "File \"$f\" was not deleted" ; 
								busybox echo "Check free space on \"$bkdir\" or if you have needed permissions" ; 
								busybox echo "Uninstall will stop. Launch it again after fixing write issue to \"$bkdir\"" ; 
								exit 1 ; 
						fi ; 
						busybox echo "$f linking to $gnr backed-up. Now deleting" ; 
						busybox rm $f ; 
						ndeletes=`busybox expr $ndeletes + 1` ; 
					else busybox echo "$f is not linked to busybox, but to $gnr ---> file not deleted">>$bkdir/bb-uninstall.log ; 
				fi ; 
		done 
done 

echo >>$bkdir/bb-uninstall.log ; 
echo "=========================================">>$bkdir/bb-uninstall.log ; 
echo "  Busybox Uninstaller v1.0 Completed !!  ">>$bkdir/bb-uninstall.log ; 
echo "=========================================">>$bkdir/bb-uninstall.log ; 
echo "               - Details -               ">>$bkdir/bb-uninstall.log ; 
echo "Number of deleted files: $ndeletes">>$bkdir/bb-uninstall.log ; 
echo "Busybox cleaned folders: \"$bbdir\"">>$bkdir/bb-uninstall.log ; 
echo "Backup folder: \"$bkdir\"">>$bkdir/bb-uninstall.log ; 
echo "Log file: \"$bkdir/bb-uninstall.log\"">>$bkdir/bb-uninstall.log ; 
echo >>$bkdir/bb-uninstall.log ; 
echo "=========================================">>$bkdir/bb-uninstall.log ; 
echo "Brought to you by Phil3759@xda-developers">>$bkdir/bb-uninstall.log ; 
echo "=========================================">>$bkdir/bb-uninstall.log ; 